package uca.baptistearthur.geocaching.converters

import android.util.Log
import androidx.room.TypeConverter
import com.google.gson.Gson
import com.google.gson.reflect.TypeToken
import kotlinx.coroutines.CoroutineScope
import kotlinx.coroutines.Deferred
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.launch
import uca.baptistearthur.geocaching.model.Address
import uca.baptistearthur.geocaching.model.Place
import uca.baptistearthur.geocaching.model.RoadTripEntity
import java.util.*

class Converters {
    @TypeConverter
    fun toDate(timestamp: Long?): Date? {
        return if (timestamp == null) null else Date(timestamp)
    }

    @TypeConverter
    fun toLong(date: Date?): Long? {
        return date?.time
    }

    @TypeConverter
    fun toString(places: List<Place>): String {
        return Gson().toJson(places)
    }

    @TypeConverter
    fun toPlaces(value: String): List<Place> {
        val listType = object : TypeToken<List<Place>>() {}.type
        return Gson().fromJson(value, listType)
    }

    @TypeConverter
    fun toRoadTripEntity(value: String?): RoadTripEntity {
        return Gson().fromJson(value, RoadTripEntity::class.java)
    }

}

fun Date.toFrenchFormat(): String {
    return "${this.day}/${this.month}/${this.year} - ${this.hours}h${this.minutes}"
}