package uca.baptistearthur.geocaching.data

import android.content.Context
import androidx.room.Room
import androidx.room.RoomDatabase
import androidx.room.TypeConverters
import uca.baptistearthur.geocaching.converters.Converters
import uca.baptistearthur.geocaching.model.RoadTripEntity

@androidx.room.Database(entities = arrayOf(RoadTripEntity::class), version=1)
@TypeConverters(Converters::class)
abstract class Database : RoomDatabase(){

    abstract fun roadTripDAO(): RoadTripDAO

    companion object{
        private var INSTANCE: Database ?= null

        fun getInstance(context: Context) =
            INSTANCE ?: synchronized(this){
                val db = Room.databaseBuilder(context, Database::class.java, "roadTripDB").build()
                INSTANCE = db
            }
    }

}