package uca.baptistearthur.geocaching.ui.fragment

import android.annotation.SuppressLint
import android.os.Build
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.fragment.app.Fragment
import android.util.Log
import android.widget.TextView
import androidx.annotation.RequiresApi
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import uca.baptistearthur.geocaching.R
import uca.baptistearthur.geocaching.converters.Converters
import uca.baptistearthur.geocaching.converters.toFrenchFormat
import uca.baptistearthur.geocaching.recyclerview.PlacesAdapter
import java.time.format.DateTimeFormatter
import java.util.*

class RoadtripDetail : Fragment() {

    private var placesRecyclerView : RecyclerView? = null

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        Log.d("GeoMap", "MAP ON CREATE VIEW")
        // Inflate the layout for this fragment
        val view = inflater.inflate(R.layout.roadtrip_detail, container, false)

        var roadTripJSON = arguments?.getString("roadTrip")
        val roadTrip = Converters().toRoadTripEntity(roadTripJSON)

        placesRecyclerView = view?.findViewById(R.id.recyclerViewPlacesList)
        placesRecyclerView?.adapter = PlacesAdapter(roadTrip.places)
        placesRecyclerView?.layoutManager = LinearLayoutManager(context)

        view?.findViewById<TextView>(R.id.roadTripDetailTitle)?.text = roadTrip.name
        view?.findViewById<TextView>(R.id.roadTripDetailDate)?.text = roadTrip.date.toFrenchFormat()

        return view
    }
}